## libvpl 2.15.0

=== CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

cmake_minimum_required(VERSION 3.13.0)
if(MSVC)
  cmake_policy(SET CMP0091 NEW)
endif()

file(STRINGS "version.txt" version_txt)
project(vpl VERSION ${version_txt})

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#
# Project configuration options
#

# Set default build type to Release if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Default CMAKE_BUILD_TYPE not set using Release")
  set(CMAKE_BUILD_TYPE
      "Release"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

# More code hardening on Windows
if(MSVC)
  if(${use_control_flow_guard})
    message("Setting CONTROL FLOW GUARD")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /guard:cf")
    set(CMAKE_EXE_LINKER_FLAGS "/guard:cf /DYNAMICBASE")
  endif()
  if(${use_qspectre})
    message("Setting QSPECTRE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qspectre")
  endif()
endif()

# Project options
option(BUILD_SHARED_LIBS "Build shared instead of static libraries." ON)
option(BUILD_TESTS "Build tests." OFF)

set(INSTALL_DEV
    ON
    CACHE BOOL "Install files that are only needed for development.")
set(INSTALL_LIB
    ON
    CACHE BOOL "Install dispatcher library.")
set(INSTALL_EXAMPLES
    ON
    CACHE BOOL "Install example source code and content.")
set(BUILD_EXAMPLES
    OFF
    CACHE BOOL "Build examples when building dev package.")

set(BUILD_EXPERIMENTAL
    ON
    CACHE BOOL "Build dispatcher with EXPERIMENTAL APIs.")

if(UNIX)
  set(ENABLE_LIBDIR_IN_RUNTIME_SEARCH
      OFF
      CACHE BOOL "Include installation lib directory in runtime search path.")
endif()

option(USE_MSVC_STATIC_RUNTIME
       "Link MSVC runtime statically to all components." OFF)

if(USE_MSVC_STATIC_RUNTIME)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()

# Set output directories
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

include(cmake/InstallDirs.cmake)
include(cmake/PackageTarget.cmake)

# Set POSITION_INDEPENDENT_CODE property for all targets
set(CMAKE_POSITION_INDEPENDENT_CODE true)

# Keep executable bits on shared objects when installing regardless of distro
set(CMAKE_INSTALL_SO_NO_EXE 0)

include(cmake/CompileOptions.cmake)

if(BUILD_TESTS)
  include(CTest)
  enable_testing()
endif()

add_subdirectory(api)
add_subdirectory(libvpl)
add_subdirectory(examples)
if(INSTALL_DEV)
  add_subdirectory(env)
endif()

install(
  FILES third-party-programs.txt
  DESTINATION ${VPL_INSTALL_LICENSEDIR}
  COMPONENT ${VPL_COMPONENT_LIB})

install(
  FILES LICENSE
  RENAME license.txt
  DESTINATION ${VPL_INSTALL_LICENSEDIR}
  COMPONENT ${VPL_COMPONENT_LIB})

if(INSTALL_LIB)
  set(CMAKE_INSTALL_SYSTEM_RUNTIME_COMPONENT ${VPL_COMPONENT_LIB})
  include(InstallRequiredSystemLibraries)
endif()

message(
  STATUS "---------------- Configuration summary ------------------------------"
)
message(STATUS "CMake:")
message(STATUS "  CMAKE_VERSION                   : ${CMAKE_VERSION}")
message(STATUS "  CMAKE_GENERATOR                 : ${CMAKE_GENERATOR}")
message(STATUS "  CMAKE_BUILD_TOOL                : ${CMAKE_BUILD_TOOL}")
message(STATUS "Target:")
message(STATUS "  CMAKE_SYSTEM_NAME               : ${CMAKE_SYSTEM_NAME}")
message(STATUS "  CMAKE_SYSTEM_VERSION            : ${CMAKE_SYSTEM_VERSION}")
message(STATUS "  CMAKE_SYSTEM_PROCESSOR          : ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "General:")
message(STATUS "  CMAKE_BUILD_TYPE                : ${CMAKE_BUILD_TYPE}")
message(STATUS "  CMAKE_TOOLCHAIN_FILE            : ${CMAKE_TOOLCHAIN_FILE}")
message(STATUS "  CMAKE_C_COMPILER                : ${CMAKE_C_COMPILER}")
message(STATUS "  CMAKE_CXX_COMPILER              : ${CMAKE_CXX_COMPILER}")
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  message(STATUS "  Build architecture              : 64-bit")
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  message(STATUS "  Build architecture              : 32-bit")
endif()
message(STATUS "Flags:")
message(STATUS "  CMAKE_C_FLAGS                   : ${CMAKE_C_FLAGS}")
message(STATUS "  CMAKE_CXX_FLAGS                 : ${CMAKE_CXX_FLAGS}")
message(STATUS "Release flags:")
message(STATUS "  CMAKE_C_FLAGS_RELEASE           : ${CMAKE_C_FLAGS_RELEASE}")
message(STATUS "  CMAKE_CXX_FLAGS_RELEASE         : ${CMAKE_CXX_FLAGS_RELEASE}")
message(STATUS "Debug flags:")
message(STATUS "  CMAKE_C_FLAGS_DEBUG             : ${CMAKE_C_FLAGS_DEBUG}")
message(STATUS "  CMAKE_CXX_FLAGS_DEBUG           : ${CMAKE_CXX_FLAGS_DEBUG}")
message(STATUS "RelWithDebRT flags:")
message(
  STATUS "  CMAKE_C_FLAGS_RELWITHDEBRT      : ${CMAKE_C_FLAGS_RELWITHDEBRT}")
message(
  STATUS "  CMAKE_CXX_FLAGS_RELWITHDEBRT    : ${CMAKE_CXX_FLAGS_RELWITHDEBRT}")
message(STATUS "Install:")
message(STATUS "  CMAKE_INSTALL_PREFIX            : ${CMAKE_INSTALL_PREFIX}")
message(
  STATUS "  CMAKE_INSTALL_FULL_BINDIR       : ${CMAKE_INSTALL_FULL_BINDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_INCLUDEDIR   : ${CMAKE_INSTALL_FULL_INCLUDEDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_LIBDIR       : ${CMAKE_INSTALL_FULL_LIBDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_DOCDIR       : ${CMAKE_INSTALL_FULL_DOCDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_PKGCONFIGDIR   : ${VPL_INSTALL_FULL_PKGCONFIGDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_CMAKEDIR       : ${VPL_INSTALL_FULL_CMAKEDIR}")
message(STATUS "  VPL_INSTALL_FULL_ENVDIR         : ${VPL_INSTALL_FULL_ENVDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_MODFILEDIR     : ${VPL_INSTALL_FULL_MODFILEDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_EXAMPLEDIR     : ${VPL_INSTALL_FULL_EXAMPLEDIR}")
message(
  STATUS "  VPL_INSTALL_FULL_LICENSEDIR     : ${VPL_INSTALL_FULL_LICENSEDIR}")
message(STATUS "  INSTALL_DEV                     : ${INSTALL_DEV}")
message(STATUS "  INSTALL_LIB                     : ${INSTALL_LIB}")
message(STATUS "  INSTALL_EXAMPLES                : ${INSTALL_EXAMPLES}")
message(STATUS "Build:")
message(STATUS "  BUILD_SHARED_LIBS               : ${BUILD_SHARED_LIBS}")
message(STATUS "  BUILD_TESTS                     : ${BUILD_TESTS}")
message(STATUS "  BUILD_EXAMPLES                  : ${BUILD_EXAMPLES}")
message(STATUS "  BUILD_EXPERIMENTAL              : ${BUILD_EXPERIMENTAL}")
if(UNIX)
  message(
    STATUS
      "  ENABLE_LIBDIR_IN_RUNTIME_SEARCH : ${ENABLE_LIBDIR_IN_RUNTIME_SEARCH}")
endif()
if(MSVC)
  message(
    STATUS "  USE_MSVC_STATIC_RUNTIME         : ${USE_MSVC_STATIC_RUNTIME}")
endif()

=== examples/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

cmake_minimum_required(VERSION 3.13.0)

if(BUILD_EXAMPLES)
  add_subdirectory(api1x_core/legacy-decode)
  add_subdirectory(api1x_core/legacy-vpp)
  add_subdirectory(api1x_core/legacy-encode)
  add_subdirectory(api2x/hello-decode)
  if(WIN32)
    add_subdirectory(api2x/hello-sharing-dx11)
    add_subdirectory(api2x/hello-sharing-ocl)
  else()
    add_subdirectory(api2x/hello-sharing-vaapi)
  endif()
  add_subdirectory(api2x/hello-decvpp)
  add_subdirectory(api2x/hello-encode)
  add_subdirectory(api2x/hello-encode-jpeg)
  add_subdirectory(api2x/hello-transcode)
  add_subdirectory(api2x/hello-vpp)
  add_subdirectory(tutorials/01_transition/VPL)
endif()

if(INSTALL_EXAMPLES)
  install(
    DIRECTORY content
    DESTINATION ${VPL_INSTALL_EXAMPLEDIR}
    COMPONENT ${VPL_COMPONENT_DEV})

  install(
    DIRECTORY api1x_core/legacy-decode api1x_core/legacy-vpp
              api1x_core/legacy-encode
    DESTINATION ${VPL_INSTALL_EXAMPLEDIR}/api1x_core
    COMPONENT ${VPL_COMPONENT_DEV})

  install(
    DIRECTORY interop/vpl-infer
    DESTINATION ${VPL_INSTALL_EXAMPLEDIR}/interop
    COMPONENT ${VPL_COMPONENT_DEV})

  install(
    DIRECTORY api2x/hello-decode api2x/hello-decvpp api2x/hello-encode
              api2x/hello-transcode api2x/hello-vpp api2x/hello-encode-jpeg
    DESTINATION ${VPL_INSTALL_EXAMPLEDIR}/api2x
    COMPONENT ${VPL_COMPONENT_DEV})

  install(
    DIRECTORY tutorials/01_transition
    DESTINATION ${VPL_INSTALL_EXAMPLEDIR}/tutorials
    COMPONENT ${VPL_COMPONENT_DEV})

  if(WIN32)
    install(
      DIRECTORY api2x/hello-sharing-dx11 api2x/hello-sharing-ocl
      DESTINATION ${VPL_INSTALL_EXAMPLEDIR}/api2x
      COMPONENT ${VPL_COMPONENT_DEV})
  else()
    install(
      DIRECTORY api2x/hello-sharing-vaapi
      DESTINATION ${VPL_INSTALL_EXAMPLEDIR}/api2x
      COMPONENT ${VPL_COMPONENT_DEV})
  endif()
endif()

=== libvpl/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
set(TARGET VPL)
set(OUTPUT_NAME "vpl")
set(DLL_PREFIX "lib")

if(WIN32)
  set(SOURCES
      src/windows/main.cpp
      src/windows/mfx_critical_section.cpp
      src/windows/mfx_dispatcher.cpp
      src/windows/mfx_dispatcher_log.cpp
      src/windows/mfx_driver_store_loader.cpp
      src/windows/mfx_dxva2_device.cpp
      src/windows/mfx_function_table.cpp
      src/windows/mfx_library_iterator.cpp
      src/windows/mfx_load_dll.cpp
      src/windows/mfx_win_reg_key.cpp
      src/windows/libmfx.def)
  if(BUILD_SHARED_LIBS)
    configure_file(src/windows/version.rc.in src/windows/version.rc @ONLY)
    list(APPEND SOURCES ${CMAKE_CURRENT_BINARY_DIR}/src/windows/version.rc)
  endif()
endif()
if(UNIX)
  set(SOURCES src/linux/mfxloader.cpp)

  if(NOT DEFINED MFX_MODULES_DIR)
    set(MFX_MODULES_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
  endif()
  add_definitions(-DMFX_MODULES_DIR="${MFX_MODULES_DIR}")
  message(STATUS "MFX_MODULES_DIR=${MFX_MODULES_DIR}")
endif()

if(BUILD_EXPERIMENTAL)
  add_definitions(-DONEVPL_EXPERIMENTAL)
endif()

list(
  APPEND
  SOURCES
  src/mfx_dispatcher_vpl.cpp
  src/mfx_dispatcher_vpl_loader.cpp
  src/mfx_dispatcher_vpl_config.cpp
  src/mfx_dispatcher_vpl_lowlatency.cpp
  src/mfx_dispatcher_vpl_log.cpp
  src/mfx_dispatcher_vpl_msdk.cpp
  src/mfx_config_interface/mfx_config_interface.cpp
  src/mfx_config_interface/mfx_config_interface_string_api.cpp)

add_library(${TARGET} "")

# disable warnings for dispatcher library itself but not subprojects (unit
# tests)
set_target_properties(${TARGET} PROPERTIES COMPILE_DEFINITIONS
                                           "MFX_DEPRECATED_OFF")

# optionally include the install location of dispatcher dll in the runtime
# search process
if(UNIX)
  if(ENABLE_LIBDIR_IN_RUNTIME_SEARCH)
    file(TO_CMAKE_PATH "${CMAKE_INSTALL_FULL_LIBDIR}" _install_libdir_search)
    target_compile_definitions(
      ${TARGET} PRIVATE INSTALL_LIBDIR_SEARCH=\"${_install_libdir_search}\")
    message(STATUS "Enabled install libdir search: ${_install_libdir_search}")
  endif()
endif()

if(WIN32)
  # force libxxx style sharedlib name on Windows
  if(BUILD_SHARED_LIBS)
    set_target_properties(${TARGET} PROPERTIES PREFIX ${DLL_PREFIX})
  endif()
  set(SHLIB_FILE_NAME ${DLL_PREFIX}${OUTPUT_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX})
  set(SHLIB_FILE_NAME_DEBUG
      ${DLL_PREFIX}${OUTPUT_NAME}${CMAKE_DEBUG_POSTFIX}${CMAKE_SHARED_LIBRARY_SUFFIX}
  )

else()
  # use version script on Linux
  set_target_properties(
    ${TARGET}
    PROPERTIES
      LINK_FLAGS
      "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/src/linux/libvpl.map")
  set(SHLIB_FILE_NAME
      ${CMAKE_SHARED_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}.${API_VERSION_MAJOR}
  )
  set(SHLIB_FILE_NAME_DEBUG ${SHLIB_FILE_NAME})
endif()

set(LIB_FILE_NAME
    ${CMAKE_STATIC_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_STATIC_LIBRARY_SUFFIX})
set(IMPLIB_FILE_NAME
    ${CMAKE_IMPORT_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_IMPORT_LIBRARY_SUFFIX})
set(LIB_FILE_NAME_DEBUG
    ${CMAKE_STATIC_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_DEBUG_POSTFIX}${CMAKE_STATIC_LIBRARY_SUFFIX}
)
set(IMPLIB_FILE_NAME_DEBUG
    ${CMAKE_IMPORT_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_DEBUG_POSTFIX}${CMAKE_IMPORT_LIBRARY_SUFFIX}
)

set_target_properties(
  ${TARGET}
  PROPERTIES OUTPUT_NAME ${OUTPUT_NAME} SOVERSION ${API_VERSION_MAJOR}
             VERSION ${API_VERSION_MAJOR}.${API_VERSION_MINOR})

target_sources(${TARGET} PRIVATE ${SOURCES})

if(UNIX)
  # require pthreads for loading legacy MSDK runtimes
  set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
  set(THREADS_PREFER_PTHREAD_FLAG TRUE)
  find_package(Threads REQUIRED)
  if(BUILD_SHARED_LIBS)
    target_link_libraries(${TARGET} PRIVATE Threads::Threads)
  else()
    target_link_libraries(${TARGET} PUBLIC Threads::Threads)
  endif()
endif()

target_link_libraries(${TARGET} PUBLIC vpl-api)
if(BUILD_SHARED_LIBS)
  target_link_libraries(${TARGET} PRIVATE ${CMAKE_DL_LIBS})
else()
  target_link_libraries(${TARGET} PUBLIC ${CMAKE_DL_LIBS})
endif()

target_include_directories(${TARGET} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
                                             ${CMAKE_CURRENT_BINARY_DIR})

if(INSTALL_LIB)
  install(
    TARGETS ${TARGET}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            COMPONENT ${VPL_COMPONENT_LIB}
            NAMELINK_SKIP
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT ${VPL_COMPONENT_LIB})
endif()

if(INSTALL_DEV)
  install(
    TARGETS ${TARGET}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            COMPONENT ${VPL_COMPONENT_DEV}
            NAMELINK_ONLY)
  if(WIN32)
    install(TARGETS ${TARGET} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
                                      COMPONENT ${VPL_COMPONENT_DEV})
  endif()

  file(RELATIVE_PATH cmake_rel_prefix ${CMAKE_INSTALL_FULL_LIBDIR}/cmake/vpl
       ${CMAKE_INSTALL_PREFIX})
  file(RELATIVE_PATH cmake_rel_libdir ${CMAKE_INSTALL_FULL_LIBDIR}/cmake/vpl
       ${CMAKE_INSTALL_FULL_LIBDIR})
  file(RELATIVE_PATH cmake_rel_incdir ${CMAKE_INSTALL_FULL_LIBDIR}/cmake/vpl
       ${CMAKE_INSTALL_FULL_INCLUDEDIR})
  file(RELATIVE_PATH cmake_rel_bindir ${CMAKE_INSTALL_FULL_LIBDIR}/cmake/vpl
       ${CMAKE_INSTALL_FULL_BINDIR})

  configure_file(cmake/VPLConfig.cmake.in cmake/VPLConfig.cmake @ONLY)
  configure_file(cmake/VPLConfigVersion.cmake.in cmake/VPLConfigVersion.cmake
                 @ONLY)

  install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/cmake/VPLConfig.cmake"
          "${CMAKE_CURRENT_BINARY_DIR}/cmake/VPLConfigVersion.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/vpl"
    COMPONENT ${VPL_COMPONENT_DEV})

  file(RELATIVE_PATH pc_rel_prefix ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig
       ${CMAKE_INSTALL_PREFIX})
  file(RELATIVE_PATH pc_rel_libdir ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig
       ${CMAKE_INSTALL_FULL_LIBDIR})
  file(RELATIVE_PATH pc_rel_incdir ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig
       ${CMAKE_INSTALL_FULL_INCLUDEDIR})
  set(pc_rel_prefix "$\{pcfiledir}/${pc_rel_prefix}")
  set(pc_rel_libdir "$\{pcfiledir}/${pc_rel_libdir}")
  set(pc_rel_incdir "$\{pcfiledir}/${pc_rel_incdir}")

  if(CMAKE_DL_LIBS)
    set(DL_LIBS "-l${CMAKE_DL_LIBS}")
  endif()
  if(MINGW)
    # being conservative by restricting to MinGW, these are probably ok for
    # WIN32 in general
    set(MINGW_LIBS "-lole32 -lgdi32 -luuid")
  endif()
  set(VPL_PKGCONFIG_DEPENDENT_LIBS
      "${DL_LIBS} ${CMAKE_THREAD_LIBS_INIT} ${MINGW_LIBS} ${CXX_LIB}")
  configure_file("pkgconfig/vpl.pc.in" "pkgconfig/vpl.pc" @ONLY)
  install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/pkgconfig/vpl.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
    COMPONENT ${VPL_COMPONENT_DEV})
endif()

if(BUILD_TESTS)
  add_subdirectory(test)
endif()

=== doc/spec/requirements.txt ===
# SPDX-FileCopyrightText: 2019-2020 Intel Corporation
#
# SPDX-License-Identifier: MIT

# This is the minimal set of components required and using the latest
#  versions

breathe
pre-commit
sphinx==6.2.0
# waiting for pypi release for fix for parallel read
git+https://github.com/readthedocs/sphinx-notfound-page.git
# Waiting for release of: https://github.com/executablebooks/sphinx-book-theme/commit/0bdacc0a5e0a01ca5b4476651d1a80821b9b5d67
git+https://github.com/executablebooks/sphinx-book-theme.git@v1.0.1
docutils
sphinx-prompt
sphinx_substitution_extensions
sphinx_tabs
sphinxcontrib-spelling
sphinxcontrib-svg2pdfconverter
sphinxmark
graphviz
lxml==4.9.4
sphinxcontrib.plantuml

=== libvpl/test/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)

add_subdirectory(runtimes/stub)
add_subdirectory(runtimes/stub1x)
add_subdirectory(runtimes/stub-nofn)

# Build googletest
set(BUILD_SHARED_LIBS OFF)

set(BUILD_GMOCK
    OFF
    CACHE BOOL "" FORCE)
set(INSTALL_GTEST
    OFF
    CACHE BOOL "" FORCE)
set(gtest_disable_pthreads
    OFF
    CACHE BOOL "" FORCE)
set(gtest_force_shared_crt
    ON
    CACHE BOOL "" FORCE)
set(gtest_hide_internal_symbols
    OFF
    CACHE BOOL "" FORCE)

#
add_subdirectory(ext/googletest)
add_library(GTest::gtest ALIAS gtest)
add_library(GTest::gtest_main ALIAS gtest_main)

add_subdirectory(diagnostic)
add_subdirectory(unit)

=== examples/api1x_core/legacy-encode/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(legacy-encode)

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(TARGET legacy-encode)
set(SOURCES src/legacy-encode.cpp)

# Set default build type to RelWithDebInfo if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(
    STATUS "Default CMAKE_BUILD_TYPE not set using Release with Debug Info")
  set(CMAKE_BUILD_TYPE
      "RelWithDebInfo"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

add_executable(${TARGET} ${SOURCES})

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  if(NOT DEFINED ENV{VSCMD_VER})
    set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
  endif()
endif()

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} VPL::dispatcher)

if(UNIX)
  set(LIBVA_SUPPORT
      ON
      CACHE BOOL "Enable hardware support.")
  if(LIBVA_SUPPORT)
    find_package(PkgConfig REQUIRED)
    # note: pkg-config version for libva is *API* version
    pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
    pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)
    if(PKG_LIBVA_FOUND)
      target_compile_definitions(${TARGET} PUBLIC -DLIBVA_SUPPORT)
      set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
      set(THREADS_PREFER_PTHREAD_FLAG TRUE)
      find_package(Threads REQUIRED)
      target_link_libraries(${TARGET} PkgConfig::PKG_LIBVA
                            PkgConfig::PKG_LIBVA_DRM Threads::Threads)
      target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
    else()
      message(
        SEND_ERROR
          "libva not found: set LIBVA_SUPPORT=OFF to build ${TARGET} without libva support"
      )
    endif()
  else()
    message(STATUS "Building ${TARGET} without hardware support")
  endif()
endif()

# copy dependent dlls to target location
if(WIN32)
  if(${CMAKE_VERSION} VERSION_LESS "3.26")
    message(
      STATUS
        "CMake Version less than 3.26, unable to copy dependent DLLs to target location"
    )
  else()
    add_custom_command(
      TARGET ${TARGET}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy -t $<TARGET_FILE_DIR:${TARGET}>
              $<TARGET_RUNTIME_DLLS:${TARGET}>
      COMMAND_EXPAND_LISTS)
  endif()
endif()

include(CTest)
set(VPL_CONTENT_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/../../content
    CACHE PATH "Path to content.")
if(IMPL_ARG EQUAL -hw)
  set(content_file cars_320x240.nv12)
else()
  set(content_file cars_320x240.i420)
endif()
add_test(NAME ${TARGET}-test
         COMMAND ${TARGET} -i "${VPL_CONTENT_DIR}/${content_file}" -w 320 -h
                 240)

=== examples/api2x/hello-decode/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(hello-decode)

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32 AND CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(CMAKE_LIBRARY_ARCHITECTURE x86)
endif()

if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(TARGET hello-decode)
set(SOURCES src/hello-decode.cpp)

# Set default build type to RelWithDebInfo if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(
    STATUS "Default CMAKE_BUILD_TYPE not set using Release with Debug Info")
  set(CMAKE_BUILD_TYPE
      "RelWithDebInfo"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

add_executable(${TARGET} ${SOURCES})

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  if(NOT DEFINED ENV{VSCMD_VER})
    set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
  endif()
endif()

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} VPL::dispatcher)

if(UNIX)
  set(LIBVA_SUPPORT
      ON
      CACHE BOOL "Enable hardware support.")
  if(LIBVA_SUPPORT)
    find_package(PkgConfig REQUIRED)
    # note: pkg-config version for libva is *API* version
    pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
    pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)
    if(PKG_LIBVA_FOUND)
      target_compile_definitions(${TARGET} PUBLIC -DLIBVA_SUPPORT)
      set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
      set(THREADS_PREFER_PTHREAD_FLAG TRUE)
      find_package(Threads REQUIRED)
      target_link_libraries(${TARGET} PkgConfig::PKG_LIBVA
                            PkgConfig::PKG_LIBVA_DRM Threads::Threads)
      target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
    else()
      message(
        SEND_ERROR
          "libva not found: set LIBVA_SUPPORT=OFF to build ${TARGET} without libva support"
      )
    endif()
  else()
    message(STATUS "Building ${TARGET} without hardware support")
  endif()
endif()

# copy dependent dlls to target location
if(WIN32)
  if(${CMAKE_VERSION} VERSION_LESS "3.26")
    message(
      STATUS
        "CMake Version less than 3.26, unable to copy dependent DLLs to target location"
    )
  else()
    add_custom_command(
      TARGET ${TARGET}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy -t $<TARGET_FILE_DIR:${TARGET}>
              $<TARGET_RUNTIME_DLLS:${TARGET}>
      COMMAND_EXPAND_LISTS)
  endif()
endif()

include(CTest)
set(VPL_CONTENT_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/../../content
    CACHE PATH "Path to content.")
add_test(NAME ${TARGET}-test COMMAND ${TARGET} -i
                                     "${VPL_CONTENT_DIR}/cars_320x240.h265")

=== examples/api2x/hello-encode-jpeg/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(hello-encode-jpeg)

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32 AND CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(CMAKE_LIBRARY_ARCHITECTURE x86)
endif()

if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(TARGET hello-encode-jpeg)
set(SOURCES src/hello-encode-jpeg.cpp)

# Set default build type to RelWithDebInfo if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(
    STATUS "Default CMAKE_BUILD_TYPE not set using Release with Debug Info")
  set(CMAKE_BUILD_TYPE
      "RelWithDebInfo"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

add_executable(${TARGET} ${SOURCES})

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  if(NOT DEFINED ENV{VSCMD_VER})
    set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
  endif()
endif()

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} VPL::dispatcher)
if(UNIX)
  set(LIBVA_SUPPORT
      ON
      CACHE BOOL "Enable hardware support.")
  if(LIBVA_SUPPORT)
    find_package(PkgConfig REQUIRED)
    # note: pkg-config version for libva is *API* version
    pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
    pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)
    if(PKG_LIBVA_FOUND)
      target_compile_definitions(${TARGET} PUBLIC -DLIBVA_SUPPORT)
      set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
      set(THREADS_PREFER_PTHREAD_FLAG TRUE)
      find_package(Threads REQUIRED)
      target_link_libraries(${TARGET} PkgConfig::PKG_LIBVA
                            PkgConfig::PKG_LIBVA_DRM Threads::Threads)
      target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
    else()
      message(
        SEND_ERROR
          "libva not found: set LIBVA_SUPPORT=OFF to build ${TARGET} without libva support"
      )
    endif()
  else()
    message(STATUS "Building ${TARGET} without hardware support")
  endif()
endif()

# copy dependent dlls to target location
if(WIN32)
  if(${CMAKE_VERSION} VERSION_LESS "3.26")
    message(
      STATUS
        "CMake Version less than 3.26, unable to copy dependent DLLs to target location"
    )
  else()
    add_custom_command(
      TARGET ${TARGET}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy -t $<TARGET_FILE_DIR:${TARGET}>
              $<TARGET_RUNTIME_DLLS:${TARGET}>
      COMMAND_EXPAND_LISTS)
  endif()
endif()

include(CTest)
set(VPL_CONTENT_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/../../content
    CACHE PATH "Path to content.")

if(${IMPL_ARG} MATCHES "-hw")
  # nv12 jpeg enc
  add_test(NAME ${TARGET}-nv12-test
           COMMAND ${TARGET} -i "${VPL_CONTENT_DIR}/cars_320x240.nv12" -w 320
                   -h 240)
  set(passRegex "Encoded 30 frames" "^All ok")
  set_property(TEST ${TARGET}-nv12-test PROPERTY PASS_REGULAR_EXPRESSION
                                                 "${passRegex}")
  # bgr4 jpeg enc
  add_test(NAME ${TARGET}-bgr4-test
           COMMAND ${TARGET} -i "${VPL_CONTENT_DIR}/cars_320x240.bgra" -w 320
                   -h 240 -bgr4)
  set(passRegex "Encoded 30 frames" "^All ok")
  set_property(TEST ${TARGET}-bgr4-test PROPERTY PASS_REGULAR_EXPRESSION
                                                 "${passRegex}")

  if(NOT WIN32)
    # yuv400 jpeg enc
    add_test(NAME ${TARGET}-yuv400-test
             COMMAND ${TARGET} -i "${VPL_CONTENT_DIR}/cars_320x240.y8" -w 320
                     -h 240 -yuv400)
    set(passRegex "Encoded 30 frames" "^All ok")
    set_property(TEST ${TARGET}-yuv400-test PROPERTY PASS_REGULAR_EXPRESSION
                                                     "${passRegex}")
  endif()
endif()

=== examples/api2x/hello-encode/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(hello-encode)

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32 AND CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(CMAKE_LIBRARY_ARCHITECTURE x86)
endif()

if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(TARGET hello-encode)
set(SOURCES src/hello-encode.cpp)

# Set default build type to RelWithDebInfo if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(
    STATUS "Default CMAKE_BUILD_TYPE not set using Release with Debug Info")
  set(CMAKE_BUILD_TYPE
      "RelWithDebInfo"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

add_executable(${TARGET} ${SOURCES})

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  if(NOT DEFINED ENV{VSCMD_VER})
    set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
  endif()
endif()

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} VPL::dispatcher)
if(UNIX)
  set(LIBVA_SUPPORT
      ON
      CACHE BOOL "Enable hardware support.")
  if(LIBVA_SUPPORT)
    find_package(PkgConfig REQUIRED)
    # note: pkg-config version for libva is *API* version
    pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
    pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)
    if(PKG_LIBVA_FOUND)
      target_compile_definitions(${TARGET} PUBLIC -DLIBVA_SUPPORT)
      set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
      set(THREADS_PREFER_PTHREAD_FLAG TRUE)
      find_package(Threads REQUIRED)
      target_link_libraries(${TARGET} PkgConfig::PKG_LIBVA
                            PkgConfig::PKG_LIBVA_DRM Threads::Threads)
      target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
    else()
      message(
        SEND_ERROR
          "libva not found: set LIBVA_SUPPORT=OFF to build ${TARGET} without libva support"
      )
    endif()
  else()
    message(STATUS "Building ${TARGET} without hardware support")
  endif()
endif()

# copy dependent dlls to target location
if(WIN32)
  if(${CMAKE_VERSION} VERSION_LESS "3.26")
    message(
      STATUS
        "CMake Version less than 3.26, unable to copy dependent DLLs to target location"
    )
  else()
    add_custom_command(
      TARGET ${TARGET}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy -t $<TARGET_FILE_DIR:${TARGET}>
              $<TARGET_RUNTIME_DLLS:${TARGET}>
      COMMAND_EXPAND_LISTS)
  endif()
endif()

include(CTest)
set(VPL_CONTENT_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/../../content
    CACHE PATH "Path to content.")
if(IMPL_ARG EQUAL -hw)
  set(content_file cars_320x240.nv12)
else()
  set(content_file cars_320x240.i420)
endif()
add_test(NAME ${TARGET}-test
         COMMAND ${TARGET} -i "${VPL_CONTENT_DIR}/${content_file}" -w 320 -h
                 240)

=== examples/api2x/hello-sharing-dx11/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(hello-sharing-dx11)

# Enable experimental mode
add_definitions(-DONEVPL_EXPERIMENTAL)

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32 AND CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(CMAKE_LIBRARY_ARCHITECTURE x86)
endif()

if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(DX11_TARGETS hello-sharing-dx11-export hello-sharing-dx11-import)
foreach(target IN LISTS DX11_TARGETS)
  set(TARGET ${target})
  set(SOURCES src/${target}.cpp src/device-d3d11.cpp)
  add_executable(${target} ${SOURCES})
  target_include_directories(${target}
                             PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)

  # Set default build type to RelWithDebInfo if not specified
  if(NOT CMAKE_BUILD_TYPE)
    message(
      STATUS "Default CMAKE_BUILD_TYPE not set using Release with Debug Info")
    set(CMAKE_BUILD_TYPE
        "RelWithDebInfo"
        CACHE
          STRING
          "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
          FORCE)
  endif()

  if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    if(NOT DEFINED ENV{VSCMD_VER})
      set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
    endif()
  endif()

  find_package(VPL REQUIRED)
  target_link_libraries(${target} VPL::dispatcher)
  if(WIN32)
    # Windows dependencies
    target_link_libraries(${target} dxgi d3d11)
  endif()

  if(UNIX)
    set(LIBVA_SUPPORT
        ON
        CACHE BOOL "Enable hardware support.")
    if(LIBVA_SUPPORT)
      find_package(PkgConfig REQUIRED)
      # note: pkg-config version for libva is *API* version
      pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
      pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)
      if(PKG_LIBVA_FOUND)
        target_compile_definitions(${target} PUBLIC -DLIBVA_SUPPORT)
        set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
        set(THREADS_PREFER_PTHREAD_FLAG TRUE)
        find_package(Threads REQUIRED)
        target_link_libraries(${target} PkgConfig::PKG_LIBVA
                              PkgConfig::PKG_LIBVA_DRM Threads::Threads)
        target_include_directories(${target} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
      else()
        message(
          SEND_ERROR
            "libva not found: set LIBVA_SUPPORT=OFF to build ${TARGET} without libva support"
        )
      endif()
    else()
      message(STATUS "Building ${TARGET} without hardware support")
    endif()
  endif()

  # copy dependent dlls to target location
  if(WIN32)
    if(${CMAKE_VERSION} VERSION_LESS "3.26")
      message(
        STATUS
          "CMake Version less than 3.26, unable to copy dependent DLLs to target location"
      )
    else()
      add_custom_command(
        TARGET ${TARGET}
        POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy -t $<TARGET_FILE_DIR:${TARGET}>
                $<TARGET_RUNTIME_DLLS:${TARGET}>
        COMMAND_EXPAND_LISTS)
    endif()
  endif()
endforeach()

include(CTest)
set(VPL_CONTENT_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/../../content
    CACHE PATH "Path to content.")

# Import test
add_test(NAME hello-sharing-dx11-import-test
         COMMAND hello-sharing-dx11-import -i
                 "${VPL_CONTENT_DIR}/cars_320x240.nv12" -w 320 -h 240)
set(passRegex "Encoded 30 frames" "^All ok")
set_property(TEST hello-sharing-dx11-import-test
             PROPERTY PASS_REGULAR_EXPRESSION "${passRegex}")
# Export test
add_test(NAME hello-sharing-dx11-export-test
         COMMAND hello-sharing-dx11-export -i
                 "${VPL_CONTENT_DIR}/cars_320x240.h265")
set(passRegex "Decoded 30 frames" "^All ok")
set_property(TEST hello-sharing-dx11-export-test
             PROPERTY PASS_REGULAR_EXPRESSION "${passRegex}")

=== examples/api2x/hello-sharing-vaapi/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(hello-sharing-vaapi)

# Enable experimental mode
add_compile_definitions(ONEVPL_EXPERIMENTAL)

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(VAAPI_TARGETS hello-sharing-vaapi-export hello-sharing-vaapi-import)
foreach(target IN LISTS VAAPI_TARGETS)
  set(TARGET ${target})
  set(SOURCES src/${target}.cpp src/device-vaapi.cpp)
  add_executable(${target} ${SOURCES})
  target_include_directories(${target}
                             PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)

  # Set default build type to RelWithDebInfo if not specified
  if(NOT CMAKE_BUILD_TYPE)
    message(
      STATUS "Default CMAKE_BUILD_TYPE not set using Release with Debug Info")
    set(CMAKE_BUILD_TYPE
        "RelWithDebInfo"
        CACHE
          STRING
          "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
          FORCE)
  endif()

  if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    if(NOT DEFINED ENV{VSCMD_VER})
      set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
    endif()
  endif()

  find_package(VPL REQUIRED)
  target_link_libraries(${target} PRIVATE VPL::dispatcher)

  if(UNIX)
    set(LIBVA_SUPPORT
        ON
        CACHE BOOL "Enable hardware support.")
    if(LIBVA_SUPPORT)
      find_package(PkgConfig REQUIRED)
      find_package(Threads REQUIRED)
      # note: pkg-config version for libva is *API* version
      pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
      pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)
      if(PKG_LIBVA_FOUND)
        target_compile_definitions(${target} PUBLIC -DLIBVA_SUPPORT)
        set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
        set(THREADS_PREFER_PTHREAD_FLAG TRUE)
        target_link_libraries(${target} PRIVATE Threads::Threads)
        target_link_libraries(${target} PRIVATE PkgConfig::PKG_LIBVA
                                                PkgConfig::PKG_LIBVA_DRM)
        target_include_directories(${target} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
      else()
        message(
          SEND_ERROR
            "libva not found: set LIBVA_SUPPORT=OFF to build ${TARGET} without libva support"
        )
      endif()
    else()
      message(STATUS "Building ${TARGET} without hardware support")
    endif()
  endif()

endforeach()

include(CTest)
set(VPL_CONTENT_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/../../content
    CACHE PATH "Path to content.")

# Import test
add_test(NAME hello-sharing-vaapi-import-test
         COMMAND hello-sharing-vaapi-import -i
                 "${VPL_CONTENT_DIR}/cars_320x240.nv12" -w 320 -h 240)
set(passRegex "Encoded 30 frames" "^All ok")
set_property(TEST hello-sharing-vaapi-import-test
             PROPERTY PASS_REGULAR_EXPRESSION "${passRegex}")

# Export test
add_test(NAME hello-sharing-vaapi-export-test
         COMMAND hello-sharing-vaapi-export -i
                 "${VPL_CONTENT_DIR}/cars_320x240.h265")
set(passRegex "Decoded 30 frames" "^All ok")
set_property(TEST hello-sharing-vaapi-export-test
             PROPERTY PASS_REGULAR_EXPRESSION "${passRegex}")

=== examples/interop/vpl-infer/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(vpl-infer)

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()

  if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    if(NOT DEFINED ENV{VSCMD_VER})
      set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
    endif()
  endif()
endif()

set(TARGET vpl-infer)
file(GLOB_RECURSE SOURCES "src/*.cpp" "src/*.hpp")
source_group(TREE ${CMAKE_CURRENT_SOURCE_DIR} FILES ${SOURCES})

# Set default build type to RelWithDebInfo if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(
    STATUS "Default CMAKE_BUILD_TYPE not set using Release with Debug Info")
  set(CMAKE_BUILD_TYPE
      "RelWithDebInfo"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

add_executable(${TARGET} ${SOURCES})

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} PRIVATE VPL::dispatcher)

find_package(OpenVINO COMPONENTS Runtime REQUIRED)
target_link_libraries(${TARGET} PRIVATE openvino::runtime)

if(WIN32)
  find_package(OpenCL CONFIG)
else()
  find_package(OpenCL)
endif()
if(OpenCL_FOUND)
  target_link_libraries(${TARGET} PRIVATE OpenCL::OpenCL)
  add_definitions(-DZEROCOPY)
  message(STATUS "Building ${TARGET} with zerocopy support")
else()
  message(STATUS "Building ${TARGET} WITHOUT zerocopy support")
endif()

if(UNIX)
  include(CheckIncludeFileCXX)
  set(LIBVA_SUPPORT
      ON
      CACHE BOOL "Enable hardware support.")
  if(LIBVA_SUPPORT)
    find_package(PkgConfig REQUIRED)
    # note: pkg-config version for libva is *API* version

    pkg_check_modules(PKG_LIBVA libva>=1.2)
    if(PKG_LIBVA_FOUND)
      target_compile_definitions(${TARGET} PUBLIC -DLIBVA_SUPPORT)
      target_link_libraries(${TARGET} PRIVATE ${PKG_LIBVA_LIBRARIES})
      target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDEDIR})
    else()
      message(FATAL_ERROR "libva not found")
    endif()

    pkg_check_modules(PKG_LIBVADRM libva-drm>=1.2)
    if(PKG_LIBVADRM_FOUND)
      target_compile_definitions(${TARGET} PUBLIC -DLIBVA_SUPPORT)
      target_link_libraries(${TARGET} PRIVATE ${PKG_LIBVADRM_LIBRARIES})
      target_include_directories(${TARGET} PUBLIC ${PKG_LIBVADRM_INCLUDEDIR})
    else()
      message(FATAL_ERROR "libva-drm not found")
    endif()
  else()
    message(STATUS "Building ${TARGET} without hardware support")
  endif()
endif()

# copy dependent dlls to target location
if(WIN32)
  if(${CMAKE_VERSION} VERSION_LESS "3.26")
    message(
      STATUS
        "CMake Version less than 3.26, unable to copy dependent DLLs to target location"
    )
  else()
    add_custom_command(
      TARGET ${TARGET}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy -t $<TARGET_FILE_DIR:${TARGET}>
              $<TARGET_RUNTIME_DLLS:${TARGET}>
      COMMAND ${CMAKE_COMMAND} -E remove
              $<TARGET_FILE_DIR:${TARGET}>/openvino.dll
      COMMAND_EXPAND_LISTS)
  endif()
endif()

include(CTest)

set(VPL_EXAMPLE_MODEL
    "vehicle-detection-0200.xml"
    CACHE PATH "Model to use.")
set(VPL_CONTENT_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/../../content
    CACHE PATH "Path to content.")

add_test(
  NAME downloadModelXml
  COMMAND
    curl -LJO
    "https://storage.openvinotoolkit.org/repositories/open_model_zoo/2023.0/models_bin/1/vehicle-detection-0200/FP16/vehicle-detection-0200.xml"
)
add_test(
  NAME downloadModelBin
  COMMAND
    curl -LJO
    "https://storage.openvinotoolkit.org/repositories/open_model_zoo/2023.0/models_bin/1/vehicle-detection-0200/FP16/vehicle-detection-0200.bin"
)
set_tests_properties(downloadModelXml PROPERTIES FIXTURES_SETUP DL)
set_tests_properties(downloadModelBin PROPERTIES FIXTURES_SETUP DL)

if("${TEST_ZERO_COPY}")
  add_test(NAME ${TARGET}-zerocopy-test
           COMMAND ${TARGET} -i "${VPL_CONTENT_DIR}/cars_320x240.h265"
                   -zerocopy -m "${VPL_EXAMPLE_MODEL}")

  set_tests_properties(${TARGET}-zerocopy-test PROPERTIES FIXTURES_REQUIRED DL)
endif()
if("${TEST_LEGACY_API}")
  add_test(NAME ${TARGET}-legacyapi-test
           COMMAND ${TARGET} -i "${VPL_CONTENT_DIR}/cars_320x240.h265" -legacy
                   -m "${VPL_EXAMPLE_MODEL}")

  set_tests_properties(${TARGET}-legacyapi-test PROPERTIES FIXTURES_REQUIRED DL)
endif()

=== debian/changelog ===
libvpl (1:2.15.0-1ppa1~noble1) noble; urgency=medium

  * Bump to 2.15.0
  * d/p: Adding patches to ensure example installed. 
    - 0001-Revert-Stop-requiring-INSTALL_DEV-to-build-examples.patch

 -- Mustaffa, Mustamin B <mustamin.b.mustaffa@intel.com>  Sat, 23 Aug 2025 01:28:57 +0800

libvpl (1:2.14.0-1ppa1~noble1) noble; urgency=medium

  * Bump to 2.14.0

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Thu, 27 Mar 2025 18:28:25 +0800

libvpl (1:2.13.0-1ppa1~noble1) noble; urgency=medium

  * Bump to 2.13.0
  * d/p: remove a patches already merged.
    - 0001-Add-hello-encode-jpeg-api2x-example.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Tue, 07 Jan 2025 15:58:18 +0800

libvpl (1:2.12.0-1ppa1~noble1) noble; urgency=medium

  * Bump to 2.12.0
  * d/p: remove list of patches already merged and due to split repository for
    samples app.
    - 0001-Add-in-VVC-decode-feature.patch
    - 0001-Added-cmake-install-for-metrics-monitor-tools.patch
    - 0001-Allow-SMT-exit-with-no-encode-codec-is-set.patch
    - 0001-Correct-va-attrib-for-vaapiallocator.patch
    - 0001-Enable-YUV400-JPEG-Enc-for-vaapi.patch
    - 0001-Fix-X11-rendering-for-xe.patch
    - 0001-Fix-green-output-on-Y416-format.patch
    - 0001-Revert-YUV400-JPEG-Enc-for-d3d9-and-d3d11.patch
    - 0002-Enable-YUV400-JPEG-Enc-for-d3d11.patch
    - 0002-Enable-YUV400-JPEG-Enc-for-linux-vaapi-only.patch
    - 0002-Fix-code-formatting.patch
    - 0003-Enable-YUV400-JPEG-Enc-for-d3d9.patch
    - 0003-Fix-rDRM-DMA-methods.patch
    - 0004-Force-allocator-to-use-DRM_PRIME-for-rDRM.patch
    - 0010-Fix-X11-render.patch
    - 0011-Fix-Wayland-render.patch
  * d/p: update libvpl2.install & libvpl-dev.install

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Mon, 09 Sep 2024 09:17:52 +0800

libvpl (1:2.10.2-1ppa1~noble7) noble; urgency=medium

  * debian/patches: Align patch with upstream
    - 0001-Fix-X11-rendering-for-xe.patch
    - 0002-Fix-code-formatting.patch

 -- Hoe, Sheng Yang <sheng.yang.hoe@intel.com>  Tue, 13 Aug 2024 10:45:03 +0800

libvpl (1:2.10.2-1ppa1~noble6) noble; urgency=medium

  * debian/patches: Fix X11 rendering for xe
    - 0001-Fix-X11-rendering-for-xe.patch
    - 0002-Fix-code-formatting.patch

 -- Hoe, Sheng Yang <sheng.yang.hoe@intel.com>  Fri, 26 Jul 2024 23:39:50 +0800

libvpl (1:2.10.2-1ppa1~noble5) noble; urgency=medium

  * Add VVC decode feature for sample_decode.
    - 0001-Add-in-VVC-decode-feature.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Thu, 25 Jul 2024 13:10:37 +0800

libvpl (1:2.10.2-1ppa1~noble4) noble; urgency=medium

  * Add -DBUILD_EXAMPLES=ON compile option and YUV400/BGR4 (Updated version)
    - 0001-Add-hello-encode-jpeg-api2x-example.patch

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Fri, 19 Jul 2024 14:37:57 +0800

libvpl (1:2.10.2-1ppa1~noble3) noble; urgency=medium

  * Correct YUV400/BGR4 (api1x/api2x) and aligned XE DMA rDRM
    - 0001-Revert-YUV400-JPEG-Enc-for-d3d9-and-d3d11.patch
    - 0002-Enable-YUV400-JPEG-Enc-for-linux-vaapi-only.patch
    - 0003-Fix-rDRM-DMA-methods.patch
    - 0004-Force-allocator-to-use-DRM_PRIME-for-rDRM.patch
    - 0001-Add-hello-encode-jpeg-api2x-example.patch

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Tue, 4 Jul 2024 10:13:52 +0800

libvpl (1:2.10.2-1ppa1~noble2) noble; urgency=medium

  * Correct va-attrib and enable VPL YUV400 JPEG Enc
    - 0001-Correct-va-attrib-for-vaapiallocator.patch
    - 0001-Enable-YUV400-JPEG-Enc-for-vaapi.patch
    - 0002-Enable-YUV400-JPEG-Enc-for-d3d11.patch
    - 0003-Enable-YUV400-JPEG-Enc-for-d3d9.patch

 -- LEE CHEE YANG <chee.yang.lee@intel.com>  Mon, 20 May 2024 10:50:45 +0800

libvpl (1:2.10.2-1ppa1~noble1) noble; urgency=medium

  * bump to 2.10.2
  * Fix green output on sample decode for Y416
    - 0001-Fix-green-output-for-Y416-format.patch
  * Allow SMT to exit with no encode codec is set
    - 0001-Allow-SMT-exit-with-no-encode-codec-is-set.patch

 -- LEE CHEE YANG <chee.yang.lee@intel.com>  Wed, 08 May 2024 16:06:36 +0800

onevpl (2023.4.0-1ppa1~noble1) noble; urgency=medium

  * build for ubuntu 24.04.

 -- LEE CHEE YANG <chee.yang.lee@intel.com>  Wed, 17 Apr 2024 14:42:13 +0800

onevpl (2023.4.0-1ppa1~jammy3) jammy; urgency=medium

  * missing dependency install step added

 -- Rameshkrishnan, Geddy Sekar <rameshkrishnan.geddy.sekar@intel.com>  Tue, 27 Feb 2024 23:44:21 +0530

onevpl (2023.4.0-1ppa1~jammy2) jammy; urgency=medium

  * Added cmake installing cttmetrics library and metrics monitor
    tools.
    - 0001-Added-cmake-install-for-metrics-monitor-tools.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Tue, 27 Feb 2024 12:44:14 +0800

onevpl (2023.4.0-1ppa1~jammy1) jammy; urgency=medium

  * Upstream release 2023.4.0
  * debian/patches: drop patches already merged
    - 0001-Fix-rdrm-NV12-and-P010-render-for-MTL.patch
    - 0002-Encode-more-frame-than-shortest-video-frames.patch
    - 0003-Fix-NV12-wayland-render-for-MTL.patch
    - 0004-Fix-dGfx-option-for-Linux.patch
    - 0005-Fix-rdrm-to-use-card-node-instead-of-render-node.patch
    - 0006-Fix-rdrm-tile4-selection-based-DRM-KMS-query.patch
    - 0007-Remove-unused-codes.patch
    - 0008-Enable-JPEG-BGR4-encode.patch
    - 0009-Fix-sample_decode-output-format-print.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Wed, 31 Jan 2024 10:48:33 +0800

onevpl (2023.3.1-1ppa1~jammy3) jammy; urgency=medium

  * debian/patches: Fix X11 & Wayland rendering for hybrid mode
    - 0009-Fix-sample_decode-output-format-print.patch
    - 0010-Fix-X11-render.patch
    - 0011-Fix-Wayland-render.patch

 -- Hoe, Sheng Yang <sheng.yang.hoe@intel.com>  Thu, 04 Jan 2024 09:16:36 +0800

onevpl (2023.3.1-1ppa1~jammy2) jammy; urgency=medium

  *   Enable JPEG BGR4 encode

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Fri, 17 Nov 2023 20:49:17 +0800

onevpl (2023.3.1-1ppa1~jammy1) jammy; urgency=medium

  * Upstream release 2023.3.1
  * debian/patches: rebase the list of patches.



=== debian/control ===
Source: libvpl
Section: libs
Priority: optional
Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libdrm-dev,
 libva-dev,
 libwayland-dev,
 libx11-dev,
 libx11-xcb-dev,
 libxcb1-dev,
 libxcb-dri3-dev,
 libxcb-present-dev,
 pkg-config,
 wayland-protocols,
Standards-Version: 4.7.0
Homepage: https://github.com/intel/libvpl
Vcs-Browser: https://salsa.debian.org/debian/libvpl
Vcs-Git: https://salsa.debian.org/debian/libvpl.git
Rules-Requires-Root: no

Package: libvpl2
Architecture: amd64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: oneAPI Video Processing Library -- shared library
 The oneAPI Video Processing Library (oneVPL) provides a single video processing
 API for encode, decode, and video processing that works across a wide range of
 accelerators.
 .
 This repository contains the following components of oneVPL:
 .
  - Copies of the oneVPL Specification API header files
  - oneVPL dispatcher
  - Examples demonstrating API usage
  - oneVPL command line tools
 .
 This project is part of the larger oneAPI project.
 .
 This package includes the dispatcher library

Package: libvpl-dev
Architecture: amd64 x32
Depends:
 libvpl2 (= ${binary:Version}),
 ${misc:Depends},
Description: oneAPI Video Processing Library -- development files
 The oneAPI Video Processing Library (oneVPL) provides a single video processing
 API for encode, decode, and video processing that works across a wide range of
 accelerators.
 .
 This repository contains the following components of oneVPL:
 .
  - Copies of the oneVPL Specification API header files
  - oneVPL dispatcher
  - Examples demonstrating API usage
  - oneVPL command line tools
 .
 This project is part of the larger oneAPI project.
 .
 This package includes header files and examples for development.

Package: onevpl-tools
Architecture: amd64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: oneAPI Video Processing Library -- command line tools
 The oneAPI Video Processing Library (oneVPL) provides a single video processing
 API for encode, decode, and video processing that works across a wide range of
 accelerators.
 .
 This repository contains the following components of oneVPL:
 .
  - Copies of the oneVPL Specification API header files
  - oneVPL dispatcher
  - Examples demonstrating API usage
  - oneVPL command line tools
 .
 This project is part of the larger oneAPI project.
 .
 This package includes the command line tools.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
		-DVPL_INSTALL_ENVDIR=/usr/share/vpl/env \
		-DBUILD_EXAMPLES=ON \
		-DINSTALL_EXAMPLES=ON

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/tmp/usr/share/doc/oneVPL/license.txt \
		debian/tmp/usr/share/doc/oneVPL/third-party-programs.txt \
		debian/tmp/usr/share/oneVPL/examples
